/* 
   Algorithms IE171 - Lab2 - Selection Algorithms
   Author: Matt Galati
   Revision: Menal Guzelsoy, Ted Ralphs - Jan '04
*/

#include "select.hpp"
#include <ctime>

int main(int argc, char * argv[]) 
{

   //Print command-line arguments
   if (argc < 3){ 
      cout << "Usage: select <file name> <number of elements to select>";
      cout << " <random seed>" <<endl;
      exit(1);
   }

   cout << "File name is " << argv[1] << endl;
   cout << "Number of elements to select is " << argv[2] << endl;
   if (argc > 3) cout << "Random seed is " << argv[3] << endl;
   cout << endl;
   
   clock_t start(0);                // For running time
   clock_t finish(0);               // For running time
   double  runTimeIns(0);           // For running time
   double  runTimePart(0);          // For running time
   int     numSelect(atoi(argv[2]));// How many items to select
   int     i(0), j(0);              // Loop indices
   
   // Construct the class by reading in the list of words
   Select sel(argv[1]);
   
   // Decide whether to randomize
   if (argc > 3){
      sel.setRandomSeed(atoi(argv[3]));
   }
   
   //************************* Insertion algorithm ****************************
   
   start = clock();                    
   //Perform the algorithm 1000 times to measure running time
   
   for (j = 0; j < 1000; j++){
      sel.resetList();
      sel.selectInsertion(0, sel.getListSize() - 1, numSelect);
   }
   
   finish = clock();
   runTimeIns = double(finish - start)/(CLOCKS_PER_SEC/1000.0);//in milliseconds
   
   cout << "INSERTION Algorithm Results:" << endl << endl;
   for (i = 0; i < numSelect; i++){
      cout << "Word " << i+1 << " is " << sel.getListItem(i).first 
	   << " with value = " << sel.getListItem(i).second << endl;
   }
   
   //************************* Partition algorithm ****************************
   
   sel.setStrategy(RANDOM); 
   
   start = clock();
   //Perform the algorithm 1000 times to measure running time
   for (j = 0; j < 1000; j++){
      sel.resetList();
      sel.selectPartition(0, sel.getListSize() - 1, numSelect);
   }
   finish = clock();
   runTimePart = double(finish-start)/(CLOCKS_PER_SEC / 1000.0);//in millisecond
   
   cout << endl << "PARTITION Algorithm Results:" << endl << endl;
   for (i = 0; i < numSelect; i++){
      cout << "Word " << i+1 << " is " << sel.getListItem(i).first 
	   << " with value = " << sel.getListItem(i).second << endl;
   }
   
   //Print out running times
   cout << endl << "Insertion algorithm time is ";
   cout << runTimeIns << " milliseconds." << endl;
   cout << "Partition algorithm time is ";
   cout << runTimePart << " milliseconds." << endl;
   
   return 0;
}






