/* 
   Algorithms IE171 - Lab2 - Selection Algorithms
   Author: Matt Galati
   Revision: Menal Guzelsoy, Ted Ralphs - Jan '04
*/

#ifndef SELECT_H
#define SELECT_H

#include<vector>
#include<string>
#include<cstdlib>
#include<iostream>
#include <fstream>
#include <algorithm>

using namespace std;

enum Strategy {
   ALWAYS_FIRST = 1,
   ALWAYS_LAST,
   ALWAYS_I,
   RANDOM
};

class Select{

public:

   // Constructors and destructor
   Select();
   Select(const char * filename);
   ~Select();
   
   // Query methods
   int getListSize();
   pair<string, int> getListItem(const int i);
   Strategy getStrategy();
   bool isRandomSeedSet();

   // Modification methods
   void setRandomSeed(int randomSeed);
   void setStrategy(Strategy strgy);
   void readList(const char * filename);
   void resetList();

   // List operations
   pair<string, int> selectInsertion(const int p, const int r, 
				     const int numSelect);
   pair<string, int> selectPartition(const int p, const int r, 
				     const int numSelect);

private:

   // Private data members
   pair<string, int> * list;     // The list to be sorted
   pair<string, int> * listCopy; // A copy og the original (unsorted) list
   int listSize;                 // The size of the list
   bool randomSeedSet;           // Whether the random seed has been set
   Strategy partitionStrategy;   // The strategy to use in partitioning

   // Private methods 

   // Swap two items on the list
   void swap(const int location1, const int location2);
   // Partition the list
   int partition (const int p, const int r, const int numSelect);  

};

#endif
